package org.algorithm.test;

import java.util.*;

public class Test {


    public static void main(String[] args) {
        List<Integer> data = new ArrayList<>();
        data.add(1);
        data.add(3);
        data.add(5);
        data.add(7);
        Test t = new Test();

        List<List<Integer>> workSpace = new ArrayList<>();
        for (int i = 1; i < data.size(); i++) {
            t.combinerSelect(data, new ArrayList<>(), workSpace, data.size(), i);
        }

        System.out.println(workSpace);

    }

    /**
     * 组合生成器
     *
     * @param data      原始数据
     * @param workSpace 自定义一个临时空间，用来存储每次符合条件的值
     * @param k         C(n,k)中的k
     */
    public <E> void combinerSelect(List<E> data, List<E> workSpace, List<List<E>> result, int n, int k) {
        List<E> copyData;
        List<E> copyWorkSpace = null;

        if (workSpace.size() == k) {
            for (E c : workSpace)
                System.out.print(c);

            result.add(new ArrayList<>(workSpace));
            System.out.println();
        }

        for (int i = 0; i < data.size(); i++) {
            copyData = new ArrayList<E>(data);
            copyWorkSpace = new ArrayList<E>(workSpace);

            copyWorkSpace.add(copyData.get(i));
            for (int j = i; j >= 0; j--)
                copyData.remove(j);
            combinerSelect(copyData, copyWorkSpace, result, n, k);
        }
    }

}

